=== plugins/generic/skg_statistic/CMakeLists.txt ===
#***************************************************************************
#*   Copyright (C) 2008 by S. MANKOWSKI / G. DE BURE support@mankowski.fr  *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 2 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program.  If not, see <http://www.gnu.org/licenses/>  *
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE PLUGIN_STATISTIC ::..")

PROJECT(plugin_statistic)

INCLUDE(CheckIncludeFileCXX)
CHECK_INCLUDE_FILE_CXX("sys/utsname.h" HAVE_UNAME)
IF(HAVE_UNAME)
    MESSAGE( STATUS "uname found")
    add_definitions(-DHAVE_UNAME)
ELSE(HAVE_UNAME)
    MESSAGE( STATUS "uname NOT FOUND")
ENDIF(HAVE_UNAME)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skg_statistic_SRCS
	skgstatisticplugin.cpp)

ADD_LIBRARY(skg_statistic MODULE ${skg_statistic_SRCS})
TARGET_LINK_LIBRARIES(skg_statistic KF5::Parts Qt5::Core skgbasemodeler skgbasegui)

########### install files ###############
INSTALL(TARGETS skg_statistic DESTINATION ${KDE_INSTALL_QTPLUGINDIR})
INSTALL(FILES ${PROJECT_SOURCE_DIR}/org.kde.skg-plugin-statistic.desktop DESTINATION ${KDE_INSTALL_KSERVICES5DIR})
INSTALL(FILES ${PROJECT_SOURCE_DIR}/skg_statistic.rc  DESTINATION  ${KDE_INSTALL_KXMLGUI5DIR}/skg_statistic )
