=== plugins/skrooge/skrooge_scheduled/CMakeLists.txt ===
#***************************************************************************
#*   Copyright (C) 2008 by S. MANKOWSKI / G. DE BURE support@mankowski.fr  *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 2 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program.  If not, see <http://www.gnu.org/licenses/>  *
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE PLUGIN_SCHEDULED ::..")

PROJECT(plugin_scheduled)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skrooge_scheduled_SRCS
	skgscheduledplugin.cpp
	skgscheduledpluginwidget.cpp
)

ki18n_wrap_ui(skrooge_scheduled_SRCS skgscheduledpluginwidget_base.ui skgscheduledpluginwidget_pref.ui)
kconfig_add_kcfg_files(skrooge_scheduled_SRCS skgscheduled_settings.kcfgc )

ADD_LIBRARY(skrooge_scheduled MODULE ${skrooge_scheduled_SRCS})
TARGET_LINK_LIBRARIES(skrooge_scheduled KF5::Parts KF5::ItemViews skgbasemodeler skgbasegui skgbankmodeler skgbankgui)

########### install files ###############
INSTALL(TARGETS skrooge_scheduled DESTINATION ${KDE_INSTALL_QTPLUGINDIR})
INSTALL(FILES ${PROJECT_SOURCE_DIR}/org.kde.skrooge-plugin-scheduled.desktop DESTINATION ${KDE_INSTALL_KSERVICES5DIR})
INSTALL(FILES ${PROJECT_SOURCE_DIR}/skrooge_scheduled.rc  DESTINATION  ${KDE_INSTALL_KXMLGUI5DIR}/skrooge_scheduled )
INSTALL(FILES ${PROJECT_SOURCE_DIR}/skgscheduled_settings.kcfg  DESTINATION  ${KDE_INSTALL_KCFGDIR} )
