=== debian/changelog ===
skrooge (2.17.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Qt build dependencies to 5.7.0, according to the upstream build
    system.

 -- Pino Toscano <pino@debian.org>  Mon, 17 Dec 2018 13:21:13 +0100
